searchNodes=[{"ref":"Quantity.html","title":"Quantity","type":"module","doc":"A data structure that encapsulates a decimal value with a unit."},{"ref":"Quantity.html#add/2","title":"Quantity.add/2","type":"function","doc":"See Quantity.Math.add/2."},{"ref":"Quantity.html#add!/2","title":"Quantity.add!/2","type":"function","doc":"See Quantity.Math.add!/2."},{"ref":"Quantity.html#base_value/1","title":"Quantity.base_value/1","type":"function","doc":"Extracts the base value from the quantity"},{"ref":"Quantity.html#div/2","title":"Quantity.div/2","type":"function","doc":"See Quantity.Math.div/2."},{"ref":"Quantity.html#exponent/1","title":"Quantity.exponent/1","type":"function","doc":"Extracts the exponent from the quantity"},{"ref":"Quantity.html#mult/2","title":"Quantity.mult/2","type":"function","doc":"See Quantity.Math.mult/2."},{"ref":"Quantity.html#negative?/1","title":"Quantity.negative?/1","type":"function","doc":"Test whether a Quantity is negative iex&gt; ~Q[100.00 DKK] |&gt; Quantity.negative?() false iex&gt; ~Q[0.00 DKK] |&gt; Quantity.negative?() false iex&gt; ~Q[-1.93 DKK] |&gt; Quantity.negative?() true"},{"ref":"Quantity.html#new/2","title":"Quantity.new/2","type":"function","doc":"Builds a new Quantity from a Decimal and a unit"},{"ref":"Quantity.html#new/3","title":"Quantity.new/3","type":"function","doc":"Builds a new Quantity from a base value, exponent and unit"},{"ref":"Quantity.html#parse/1","title":"Quantity.parse/1","type":"function","doc":"Parses a string representation of a quantity (perhaps generated with to_string/1) iex&gt; Quantity.parse(&quot;99.0 red_balloons&quot;) iex&gt; Quantity.parse(&quot;15 bananas/monkey&quot;) {:ok, Quantity.new(~d[15], {:div, &quot;bananas&quot;, &quot;monkey&quot;})} iex&gt; Quantity.parse(&quot;15 m*m&quot;) {:ok, Quantity.new(~d[15], {:mult, &quot;m&quot;, &quot;m&quot;})} iex&gt; Quantity.parse(&quot;bogus&quot;) :error"},{"ref":"Quantity.html#parse!/1","title":"Quantity.parse!/1","type":"function","doc":"Same as parse/1, but raises if it could not parse"},{"ref":"Quantity.html#positive?/1","title":"Quantity.positive?/1","type":"function","doc":"Test whether a Quantity is positive iex&gt; ~Q[100.00 DKK] |&gt; Quantity.positive?() true iex&gt; ~Q[0.00 DKK] |&gt; Quantity.positive?() false iex&gt; ~Q[-1.93 DKK] |&gt; Quantity.positive?() false"},{"ref":"Quantity.html#round/2","title":"Quantity.round/2","type":"function","doc":"See Quantity.Math.round/2."},{"ref":"Quantity.html#sub/2","title":"Quantity.sub/2","type":"function","doc":"See Quantity.Math.sub/2."},{"ref":"Quantity.html#sub!/2","title":"Quantity.sub!/2","type":"function","doc":"See Quantity.Math.sub!/2."},{"ref":"Quantity.html#sum/1","title":"Quantity.sum/1","type":"function","doc":"See Quantity.Math.sum/1."},{"ref":"Quantity.html#sum/3","title":"Quantity.sum/3","type":"function","doc":"See Quantity.Math.sum/3."},{"ref":"Quantity.html#sum!/1","title":"Quantity.sum!/1","type":"function","doc":"See Quantity.Math.sum!/1."},{"ref":"Quantity.html#sum!/3","title":"Quantity.sum!/3","type":"function","doc":"See Quantity.Math.sum!/3."},{"ref":"Quantity.html#to_string/1","title":"Quantity.to_string/1","type":"function","doc":"Encodes the quantity as a string. The result is parsable with parse/1 If the exponent is positive, encode usinge the &quot;raw&quot; format to preserve precision iex&gt; Quantity.new(42, -1, &quot;db&quot;) |&gt; Quantity.to_string() &quot;4.2 db&quot; iex&gt; Quantity.new(42, 1, &quot;db&quot;) |&gt; Quantity.to_string() &quot;42E1 db&quot; iex&gt; Quantity.new(~d[3600], {:div, &quot;seconds&quot;, &quot;hour&quot;}) |&gt; Quantity.to_string() &quot;3600 seconds/hour&quot; iex&gt; Quantity.new(~d[34], {:mult, &quot;m&quot;, &quot;m&quot;}) |&gt; Quantity.to_string() &quot;34 m*m&quot;"},{"ref":"Quantity.html#unit/1","title":"Quantity.unit/1","type":"function","doc":"Extracts the unit from the quantity"},{"ref":"Quantity.html#zero?/1","title":"Quantity.zero?/1","type":"function","doc":"Tests if a quantity has zero value iex&gt; Quantity.zero?(~Q[0.00 m^2]) true iex&gt; Quantity.zero?(~Q[0E7 m^2]) true iex&gt; Quantity.zero?(~Q[10 m^2]) false"},{"ref":"Quantity.html#t:t/0","title":"Quantity.t/0","type":"type","doc":""},{"ref":"Quantity.html#t:unit/0","title":"Quantity.unit/0","type":"type","doc":""},{"ref":"Quantity.Math.html","title":"Quantity.Math","type":"module","doc":"Functions for doing math with Quantities"},{"ref":"Quantity.Math.html#add/2","title":"Quantity.Math.add/2","type":"function","doc":"Add two Quantities, keeping the unit iex&gt; add(~Q[1.34 MWh], ~Q[3.49 MWh]) iex&gt; add(~Q[1.234567 days], ~Q[3.5 days]) iex&gt; add(~Q[10 goats], ~Q[40 sheep]) :error"},{"ref":"Quantity.Math.html#add!/2","title":"Quantity.Math.add!/2","type":"function","doc":"Add two Quantities, but raise an ArgumentError on error iex&gt; add!(~Q[50.94 kWh], ~Q[49.40 kWh]) ~Q[100.34 kWh]"},{"ref":"Quantity.Math.html#div/2","title":"Quantity.Math.div/2","type":"function","doc":"Divide a Quantity by a scalar or another Quantity iex&gt; Quantity.div(~Q[15 $], ~Q[10 banana]) ~Q[1.5 $/banana] iex&gt; Quantity.div(~Q[15 $], ~d[10]) ~Q[1.5 $] iex&gt; Quantity.div(~Q[15 $], ~Q[10 $]) ~d[1.5]"},{"ref":"Quantity.Math.html#mult/2","title":"Quantity.Math.mult/2","type":"function","doc":"Multiply a quantity by a scalar or another quantity iex&gt; Quantity.mult(~Q[15 $], ~d[4]) ~Q[60 $] iex&gt; Quantity.mult(~Q[15 $], ~Q[4 banana]) ~Q[60 $*banana] iex&gt; Quantity.mult(~Q[15 $/banana], ~Q[4 banana]) ~Q[60 $]"},{"ref":"Quantity.Math.html#round/2","title":"Quantity.Math.round/2","type":"function","doc":"Round a Quantity to match a precision using the :half_up strategy iex&gt; Quantity.round(~Q[1.49 DKK], 1) ~Q[1.5 DKK] iex&gt; Quantity.round(~Q[0.5 DKK], 2) ~Q[0.50 DKK]"},{"ref":"Quantity.Math.html#sub/2","title":"Quantity.Math.sub/2","type":"function","doc":"Subtract two Quantities, keeping the unit iex&gt; sub(~Q[99 bottles of beer], ~Q[2 bottles of beer]) iex&gt; sub(~Q[2 bananas], ~Q[1 apple]) :error"},{"ref":"Quantity.Math.html#sub!/2","title":"Quantity.Math.sub!/2","type":"function","doc":"Subtract two Quantities, but raise ArgumentError on error iex&gt; sub!(~Q[99 problems], ~Q[2 problems]) ~Q[97 problems]"},{"ref":"Quantity.Math.html#sum/1","title":"Quantity.Math.sum/1","type":"function","doc":"Sum a list of Quantities with identical units. Errors when addition fails or when the list is empty. iex&gt; sum([~Q[11.11 DKK], ~Q[22.22 DKK], ~Q[33.33 DKK]]) iex&gt; sum([~Q[1 EUR], ~Q[2 DKK]]) :error iex&gt; sum([]) :error"},{"ref":"Quantity.Math.html#sum/3","title":"Quantity.Math.sum/3","type":"function","doc":"Sum a list of Quantities with identical units. Includes a fallback value. The exp and unit will be used to create a Quantity with value 0 if the list is empty. iex&gt; sum([~Q[0.11 DKK], ~Q[0.22 DKK], ~Q[0.33 DKK]], -2, &quot;DKK&quot;) iex&gt; sum([], 0, &quot;DKK&quot;) iex&gt; sum([], -2, &quot;DKK&quot;) iex&gt; sum([~Q[1 EUR], ~Q[2 DKK]], -2, &quot;EUR&quot;) :error"},{"ref":"Quantity.Math.html#sum!/1","title":"Quantity.Math.sum!/1","type":"function","doc":"Sum a list of Quantities with identical units, raises ArgumentError on error iex&gt; sum!([~Q[123 DKK], ~Q[10 DKK], ~Q[39 DKK]]) ~Q[172 DKK]"},{"ref":"Quantity.Math.html#sum!/3","title":"Quantity.Math.sum!/3","type":"function","doc":"Sum a list of Quantities with identical units. Includes a fallback value. The exp and unit will be used to create a Quantity with value 0 if the list is empty. Raises ArgumentError on error. iex&gt; sum!([~Q[123 apples], ~Q[10 apples]], 0, &quot;apples&quot;) ~Q[133 apples] iex&gt; sum!([], -2, &quot;DKK&quot;) ~Q[0.00 DKK]"},{"ref":"Quantity.Sigils.html","title":"Quantity.Sigils","type":"module","doc":"Sigils related to Quantity and Decimal"},{"ref":"Quantity.Sigils.html#sigil_Q/2","title":"Quantity.Sigils.sigil_Q/2","type":"function","doc":"Construct a Quantity iex&gt; ~Q[12.340 kwh] Quantity.new(~d[12.340], &quot;kwh&quot;) iex&gt; ~Q[15 $/banana] Quantity.new(~d[15], {:div, &quot;$&quot;, &quot;banana&quot;}) iex&gt; ~Q[12.34 m*m] Quantity.new(~d[12.34], {:mult, &quot;m&quot;, &quot;m&quot;})"},{"ref":"Quantity.Sigils.html#sigil_d/2","title":"Quantity.Sigils.sigil_d/2","type":"function","doc":"Construct a Decimal iex&gt; ~d[12.340] Decimal.new(&quot;12.340&quot;)"},{"ref":"readme.html","title":"Quantity","type":"extras","doc":"Quantity A Quantity is an Elixir data structure that encapsulates values with units. This data structure can be used to carry values and units through calculations using the calculation functions in the Quantity library. ~Q[200.345 kWh] |&gt; Quantity.add(~Q[249.23 kWh]) # {:ok, ~Q[449.575 kWh]} [ ~Q[13.49 second], ~Q[12.39 second], ~Q[4.49 second] ] |&gt; Quantity.sum() # {:ok, ~Q[30.37 second]} cost = ~Q[0.40 $/banana] amount = ~Q[2000 banana] Quantity.mult(cost, amount) # ~Q[800.00 $]"},{"ref":"readme.html#usage","title":"Quantity - Usage","type":"extras","doc":"Creating Quantities A Quantity can be created in several ways, one is Quantity.parse/1 or Quantity.parse!/1, which parses a Quantity from a string: Quantity.parse(&quot;200.345 EUR&quot;) # {:ok, ~Q[200.345 EUR]} Quantity.parse!(&quot;200.345 EUR&quot;) # ~Q[200.345 EUR] Quantity.parse!(&quot;20.67 EUR/beer&quot;) # ~Q[20.67 EUR/beer] or the same as # Quantity.new(~d[20.67], {:div, &quot;EUR&quot;, &quot;beer&quot;}) Quantity.parse!(&quot;15.0 m*m&quot;) # ~Q[15.0 m*m] or the same as # Quantity.new(~d[15.0], {:mult, &quot;m&quot;, &quot;m&quot;}) The Quantity module also has new/2 which creates a Quantity from a Decimal.t() and a String.t(): Quantity.new(Decimal.new(&quot;300.445&quot;), &quot;km&quot;) # ~Q[300.445 km] And lastly a Quantity can be created from a value, an exponent and a unit: Quantity.new(6578, -2, &quot;second&quot;) # ~Q[65.78 second] Addition and subtraction Basic math can be done using the add/2 and sub/2 functions along with their add!/2 and sub!/2 siblings: Quantity.add(~Q[500 mL coffee], ~Q[250 mL coffee]) # {:ok, ~Q[750 mL coffee]} Quantity.add!(~Q[500 mL coffee], ~Q[250 mL coffee]) # ~Q[750 mL coffee] Quantity.sub(~Q[250 gram], ~Q[125 gram]) # {:ok, ~Q[125 gram]} Quantity.sub!(~Q[250 gram], ~Q[125 gram]) # ~Q[125 gram] Summation To sum non-empty lists with identical units, sum/1 and sum!/1 can be used: lap_times = [ ~Q[4.24 second], ~Q[4.59 second], ~Q[5.22 second], ~Q[3.99 second] ] lap_times |&gt; Quantity.sum() # {:ok, ~Q[18.04 second]} lap_times |&gt; Quantity.sum!() # ~Q[18.04 second] [] |&gt; Quantity.sum() # :error When a list is empty, Quantity doesn&#39;t know what precision and unit the result should have. If a Quantity with value 0 is desired when summing an empty list, one can use sum/3 and sum!/3: sales_2018 = [] sales_2019 = [ ~Q[1234.39 EUR], ~Q[228.50 EUR] ] sales_2018 |&gt; Quantity.sum(-2, &quot;EUR&quot;) # {:ok, ~Q[0.00 EUR]} sales_2019 |&gt; Quantity.sum(-2, &quot;EUR&quot;) # {:ok, ~Q[1462.89 EUR]} Multiplication and division Quantity has support for single-level complex units that are divided or multiplied: cost = ~Q[20.00 $] amount = ~Q[50 banana] cost_per_banana = Quantity.div(cost, amount) # ~Q[0.40 $/banana] new_amount = ~Q[2000 banana] Quantity.mult(cost_per_banana, new_amount) # ~Q[800.00 $] Quantity.mult(~Q[5 m], ~Q[4.3 m]) # ~Q[21.5 m*m] Quantity.mult(~Q[5 m], ~d[20.01]) # ~Q[100.05 m] The ~Q and ~d sigils Quantity has a special sigil_Q/2 sigil, as seen above. Quantities can be created using the ~Q sigil, and they are printed as ~Q when inspected. import Quantity.Sigils, only: [sigil_Q: 2] ~Q[500 bananas] # ~Q[500 bananas] # Supports :mult and :div units ~Q[0.54 $/banana] ~Q[13.2 m*m] Additionally a sigil_d/2 sigil is also present to easily create decimals: import Quantity.Sigils, only: [sigil_d: 2] ~d[123.456] #Decimal&lt;123.456&gt; Data structure Underneath, a Quantity is simply a map consisting of value and unit, where value is a Decimal.t() and unit a String.t(): ~Q[99 problems] |&gt; IO.inspect(structs: false) %{ __struct__: Quantity, unit: &quot;problems&quot;, value: %{__struct__: Decimal, coef: 99, exp: 0, sign: 1} }"},{"ref":"readme.html#versions-of-elixir-and-erlang","title":"Quantity - Versions of Elixir and Erlang","type":"extras","doc":"Quantity will be tested against the two latest minor versions of Elixir (but &gt;= 1.9) and the three latest minor versions of Erlang. In all cases the latest patch version is used. E.g. if the latest Elixir is 1.9.4 and the latest Erlang is 22.2.2, we test against: Elixir: 1.9.4 Erlang: 22.0.7, 22.1.8.1 and 22.2.2"}]